#!/bin/bash

mode=`uci -q get chirpstack.general.backend_mode`
listen_port=`uci -q get chirpstack.general.listen_port`
region=`uci -q get chirpstack.general.region`
address=`uci -q get chirpstack.mqtt.address`
broken_port=`uci -q get chirpstack.mqtt.port`
username=`uci -q get chirpstack.mqtt.user`
passwd=`uci -q get chirpstack.mqtt.passwd`
cefile=`uci -q get chirpstack.mqtt.cert_enable`
keyfile=`uci -q get chirpstack.mqtt.key_enable`
cafile=`uci -q get chirpstack.mqtt.ca_enable`



array=($mode $listen_port $region $broken_port $username $passwd)
parameters="semtech_udp 1700 %REGION% broken_port %GATEWAY_ID% psd"
nmber=0
cp /etc/chirpstack-gateway-bridge/chirpstack-gateway-bridge.toml.bak /etc/chirpstack-gateway-bridge/chirpstack-gateway-bridge.toml

for cy in $parameters
do
	sed -i "s/$cy/${array[$nmber]}/g" /etc/chirpstack-gateway-bridge/chirpstack-gateway-bridge.toml
	nmber=$((nmber+1))
done

scheme=$(echo $address | grep -e "tcp" -e "ssl" -c)
if [[ $scheme = 1 ]]; then
	scheme=`echo ${address:0:3}`
	address=`echo ${address:6}`
else
	scheme=`echo ${address:0:2}`
	address=`echo ${address:5}`
fi

sed -i 's/address/'$scheme'\:\/\/'$address'/'  /etc/chirpstack-gateway-bridge/chirpstack-gateway-bridge.toml


if [[ $cefile != 'null' ]]; then
	sed 's/CERT/'$cefile'/' -i /etc/chirpstack-gateway-bridge/chirpstack-gateway-bridge.toml
	echo $cefile
fi

if [[ $keyfile != 'null' ]]; then
        echo 123
fi
if [[ $cafile != 'null' ]]; then
        echo 123
fi
