#!/bin/bash

####Changelog
###Init script ----------2022/06/22
###Relseased   ----------
###
####xiaoye, xiaoye@dragino.cc


###Initialization parameters

HOST1=www.163.com
HOST2=8.8.8.8
IOT_TYPE=$(uci -q get gateway.general.server_type)

####Check the internet
check_internet()
{
checkinternet=$(fping $HOST1 | grep alive -c)
if [[ $checkinternet -eq 1 ]]; then
	internetstatus=1
else
	checkinternet=$(fping $HOST2 | grep alive -c)
	if [[ $checkinternet -eq 1 ]]; then
	    internetstatus=1
		echo 1 > /var/iot/internet
	else
		internetstatus=0
		echo 0 > /var/iot/internet
	fi
fi

default_route=$(ip route | grep default -c)
if [[ $default_route -eq 1 ]]; then
	echo "Internet Access: OK: via $(ip route | grep default | awk '{print "Dev:"$5,"Gateway:" $3}') "
elif [[ $default_route -eq 2 ]]; then
	echo "Internet Access: OK: via $(ip route | grep default | awk 'NR==1{print "Dev:" $5,"Gateway:" $3}') or $(ip route | grep default | awk 'NR==2{print "Dev:"$5,"Gateway:" $3}') "
else
	echo "Internet Access: Fail, no any routing table"
fi

}

###Check the iot

check_fwd()
{
	checkfwd=$(pgrep fwd)
        if [[ -n $checkfwd ]]; then
            process_status=1
			iot_status=$(sqlite3 /tmp/lgwdb.sqlite "select * from gwdb" | grep lorawan | grep online -c)
			if [ $iot_status -eq "1" ]; then
				iot_online=1
				echo "online" > /var/iot/status
			else
				iot_online=0
                echo "offline" > /var/iot/status
			fi
        else
			process_status=0
        fi
}

check_station()
{
	checkstation=$(pgrep station)
                if [[ -n $checkstation ]]; then
                        process_status=1
						iot_status=`tail /var/log/station.log | grep -e "HTTP connect failed" -e "failed" -e "Interaction with CUPS failed" -c`
                        if [ $iot_status -gt "0" ]; then
                                iot_online=0
                                echo "offline" > /var/iot/status
                        else
                                iot_online=1
                                echo "online" > /var/iot/status
                        fi
                else
					process_status=0
                fi
}

check_iot()
{
	if [[ $IOT_TYPE -eq  lorawan ]]; then
		check_fwd
		iot_service=draginofwd
	elif [[ $IOT_TYPE -eq station ]]; then
		check_station
		iot_service=draginostation
	elif [[ $IOT_TYPE -eq bridge ]]; then
		check_fwd
		iot_service=chirpstack-gateway-bridge
	fi
}

###Check the lighttpd
check_lighttpd()
{
	checklighttpd=$(pgrep lighttpd)
		if [[ -n $checklighttpd ]]; then
		        lighttpdstatus=0
		else
		        lighttpdstatus=1
		fi
}

###check ttn-lw-stack
check_ttn()
{

	checkttn=$(pgrep ttn)
	if [[ -n $checkttn ]]; then
			ttnstatus=0
	else
		ttnstatus=1
	fi
}

### check node-red
check_nodered()
{
	checknodered=$(pgrep node-red)
	if [[ -n $checknodered ]]; then
		noderedstatus=0
	else
		noderedstatus=1
	fi
}


###statr monment
while :
do
	sleep 15
	check_internet
	if [[ interstatus -le 1 ]]; then
		check_iot
		if [[ $process_status -eq 0 ]]; then
			echo "$(date) $iot_service had dead, start restating $iot_service"
			service $iot_service restart
		else
			if [[ $iot_online -eq 1 ]]; then
				echo "$(date) $iot_service is running and iot is online."
			else
				echo "$(date) $iot_service is running but iot is offline."

			fi
		fi
	fi
done
